import java.util.*;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.rmi.PortableRemoteObject;

import realtor.ContractRemote;
import realtor.ContractRemoteHome;
import realtor.Contract;
import realtor.ContractHome;
import realtor.ContractBean;


public class test_ejbs {

	/** JNDI Context Provider */
	public static String CONTEXT_PROVIDER_URL = "localhost:1099";
	/** JNDI Context class Factory Name */
	public static String CONTEXT_FACTORY_NAME = "org.jnp.interfaces.NamingContextFactory";
	public static String CONTEXT_FACTORY_PKGS = "org.jboss.naming:org.jnp.interfaces";
	/** JNDI Properties */
	private static Properties Properties = null ;

	private ContractRemoteHome contract_home;

	public test_ejbs()
	{
		get_home_interfaces();
		make_contract("c1", "May 31");
	}

	private void get_home_interfaces()
	{
		try {
			Properties Properties = new Properties ( ) ;
			Properties . put ( "Context.PROVIDER_URL" , CONTEXT_PROVIDER_URL ) ;
			Properties . put ( "java.naming.provider.url" , CONTEXT_PROVIDER_URL ) ;
			Properties . put ( "java.naming.factory.initial" , CONTEXT_FACTORY_NAME ) ;
			Properties . put ( "java.naming.factory.url.pkgs" , CONTEXT_FACTORY_PKGS ) ;

			InitialContext initial = new InitialContext(Properties);
			pl("Getting Initial Context");

			Object cont_ref = initial.lookup("MyContractBean");
			contract_home=(ContractRemoteHome)PortableRemoteObject.narrow(cont_ref, ContractRemoteHome.class);
		} catch (Exception ex) {
			pl("Caught an unexpected exception while getting home interfaces!");
			ex.printStackTrace(System.out);
		}
	}


	private ContractRemote make_contract(String id, String startDate)
	{
		try{
			pl("-----------------------------------------------------------");
			pl("Create contract with id = "+id+", & start = "+startDate);
			ContractRemote contract = contract_home.create(id, startDate);

			pl("name    --> "+contract.getStartDate());
			pl("id      --> "+contract.getId());
			pl("-----------------------------------------------------------");
			return contract;
		} catch (Exception ex) {
			pl("Caught an unexpected exception while making contract!");
			ex.printStackTrace();
		}
		return null;
	}


	public void pl(String str){System.out.println(str);}

   public static void main(String[] args) {
		test_ejbs te = new test_ejbs();
   }
}
